#include "AneuMeshLoader.h"
#include "Exceptions.h"

#include <iostream>
#include <fstream>
#include <vector>

void AneuMeshLoader::LoadMesh(const std::string& filename) {
	 std::ifstream input(filename);
	 if (!input) {
		 throw NoFileFoundException(filename);
	 }
	 else std::cout << "File \"" << filename << "\" was succesfully opened" << std::endl;

	 int dimension, amount;

	 input >> amount >> dimension;
	 for (int i = 1; i <= amount; ++i) 
{
		 Node temp_node;
		 temp_node.nodeID = i;
		 input >> temp_node.x >> temp_node.y >> temp_node.z;
		 temp_node.vertex = true;
<<<<<<< HEAD
		 nodes.insert(std::move(temp_node));//
=======
		 nodes.push_back(temp_node); //!!! std::move не помешает
>>>>>>> 1b434108a50987c6f13bfeed8c9b8da456e45fa7
	 }

	 input >> amount >> dimension;
	
	 for (int i = 1; i <= amount; ++i) 
	 {
		 FiniteElement temp_element;
		 temp_element.elementID = i;
		 input >> temp_element.materialID;
		 temp_element.nodesID.reserve(dimension);
		 int temp_id;
		 for (int j = 0; j < dimension; ++j) {
			 input >> temp_id;
			 temp_element.nodesID.push_back(temp_id);
		 }
		 elements.insert(std::move(temp_element));
	 }

	 input >> amount >> dimension;
	 for (int i = 1; i <= amount; ++i) {
		 BoundaryFiniteElement temp_surface;
		 temp_surface.surfaceID = i;
		 input >> temp_surface.boundaryID;
		 temp_surface.nodesID.reserve(dimension);
		 int temp_id;
		 for (int j = 0; j < dimension; ++j) {
			 input >> temp_id;
			 temp_surface.nodesID.push_back(temp_id);
		 }
		 std::vector<FiniteElement> temp_elements = getElementsByID(temp_surface.nodesID[0],
																	temp_surface.nodesID[1],
																    temp_surface.nodesID[2]);
		 temp_surface.elementID = temp_elements[0].elementID;
		 temp_surface.materialID = temp_elements[0].materialID;
		 boundaryFEs.insert(std::move(temp_surface));
	 }
	 input.close();


	 std::cout << "All data was loaded, closing the file..." << std::endl;
}
